'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _reactNative = require('react-native');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AfterInteractions = function (_Component) {
  _inherits(AfterInteractions, _Component);

  function AfterInteractions() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, AfterInteractions);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = AfterInteractions.__proto__ || Object.getPrototypeOf(AfterInteractions)).call.apply(_ref, [this].concat(args))), _this), _this.state = { interactionsComplete: false }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(AfterInteractions, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      _reactNative.InteractionManager.runAfterInteractions(function () {
        _this2.setState({ interactionsComplete: true });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          placeholder = _props.placeholder,
          renderPlaceholder = _props.renderPlaceholder;


      if (this.state.interactionsComplete) {
        return children;
      }

      if (placeholder) {
        return placeholder;
      }

      if (renderPlaceholder) {
        return renderPlaceholder();
      }

      return null;
    }
  }]);

  return AfterInteractions;
}(_react.Component);

AfterInteractions.propTypes = {
  children: _react.PropTypes.any,
  placeholder: _react.PropTypes.any,
  renderPlaceholder: _react.PropTypes.func
};
AfterInteractions.defaultProps = {
  placeholder: null,
  renderPlaceholder: null
};
exports.default = AfterInteractions;
