'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = renderAfterInteractions;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _afterInteractions = require('./after-interactions');

var _afterInteractions2 = _interopRequireDefault(_afterInteractions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaults = {
  placeholder: null,
  renderPlaceholder: null,
  inheritStaticProps: true
};

function renderAfterInteractions(optionsOrComponent) {
  if (typeof optionsOrComponent === 'function') {
    // only component provided
    return renderAfterInteractions()(optionsOrComponent);
  }

  var _defaults$optionsOrCo = _extends({}, defaults, optionsOrComponent),
      placeholder = _defaults$optionsOrCo.placeholder,
      renderPlaceholder = _defaults$optionsOrCo.renderPlaceholder,
      inheritStaticProps = _defaults$optionsOrCo.inheritStaticProps;

  return function (ExpensiveComponent) {
    function WrappedComponent(props) {
      return _react2.default.createElement(
        _afterInteractions2.default,
        { placeholder: placeholder, renderPlaceholder: renderPlaceholder },
        _react2.default.createElement(ExpensiveComponent, props)
      );
    }

    if (inheritStaticProps) {
      Object.assign(WrappedComponent, ExpensiveComponent);
    }

    return WrappedComponent;
  };
}
